$nocompile
'###############################################################################
'##                                                                           ##
'##                                D S 1 8 20                                 ##
'##                       ===========================                         ##
'##                                                                           ##
'##  Description: temperature measurement and convertion with 1wire sensors   ##
'##               Dallas-Maxim.                                               ##
'##                                                                           ##
'##  Author:      Hartmut Wendt                                               ##
'##  Version:     1.0                                         Date: Feb 2013  ##
'##                                                                           ##
'##  Free for personal use, credits and a short mail with your project info   ##
'##  and/or comments, improvements etc. to this library would be nice.        ##
'##                                                                           ##
'###############################################################################

Dim Temperatur(4) As Integer
Declare Sub Temp_messen(kanal As Byte)
Declare Function Convert_temp(kanal As Byte) As String

Goto Ds1820_jumpover


'###############################################################################
'##      S U B R O U T I N E S                                                ##
'###############################################################################

Sub Temp_messen(kanal As Byte)
'Temperatur mit Sensor DS1821
  Dim Temp As Integer
  Dim 1wpin As Byte

  'Kanal einem 1wire Bus zuordnen
  If Kanal = 1 Then
   1wpin = 0

  Elseif Kanal = 2 Then
   1wpin = 1

  Elseif Kanal = 3 Then
   1wpin = 2

  Else
   1wpin = 3

  End If


 'Status schreiben
 1wreset Pinc , 1wpin                                       'reset the bus
 If Err = 0 Then
  1wwrite &H0C , 1 , Pinc , 1wpin
  1wwrite &H42 , 1 , Pinc , 1wpin
  Waitms 100

  'Conversion Starten
  1wreset Pinc , 1wpin                                      'reset the bus
  1wwrite &HEE , 1 , Pinc , 1wpin
  Waitms 100


  'Temperatur messen
  1wreset Pinc , 1wpin                                      'reset the bus
  1wwrite &HAC , 1 , Pinc , 1wpin                           'read ROM command
  Temp = 1wread(1 , Pinc , 1wpin)                           'read byte
  Waitms 50
  1wreset Pinc , 1wpin                                      'reset the bus
  1wwrite &HAA , 1 , Pinc , 1wpin                           'read ROM command
  Temp = 1wread(1 , Pinc , 1wpin)                           'read byte

  'Negative Gradzahl??
  If Temp > &HC9 Then
   Temp = Temp - 256
  End If

  Temperatur(kanal) = Temp
 Else
  Waitms 250
  Temperatur(kanal) = 200                                'Kein gltiger Wert

 End If
End Sub


Function Convert_temp(kanal As Byte) As String
'Temperatur in String konvertieren
 Dim S1 As String * 8
 If Temperatur(kanal) <> 200 Then
 'gltiger Wert
  S1 = "   " + Str(temperatur(kanal))
  S1 = Right(s1 , 3):

  S1 = S1 + "C"

 Else
 'kein Sensor
  S1 = "====="

 End If
 Convert_temp = S1
End Function



Ds1820_jumpover: