$nocompile
'###############################################################################
'##                                                                           ##
'##                              D S 1 8 S 20                                 ##
'##                       ===========================                         ##
'##                                                                           ##
'##  Description: temperature measurement and convertion with 1wire sensors   ##
'##               Dallas-Maxim DS18S20                                        ##
'##                                                                           ##
'##  Version:     1.0                                       Date: March 2013  ##
'##                                                                           ##
'##  Author:      Hartmut Wendt                                               ##
'##  URL:         www.hwhardsoft.de                                           ##
'##                                                                           ##
'##  Copyright:   GNU Public License V3                                       ##
'##                                                                           ##
'##  note:                                                                    ##
'##  This program is free software: you can redistribute it and/or modify     ##
'##  it under the terms of the GNU General Public License as published by     ##
'##  the Free Software Foundation, either version 3 of the License, or        ##
'##  (at your option) any later version.                                      ##
'##  This program is distributed in the hope that it will be useful,          ##
'##  but WITHOUT ANY WARRANTY; without even the implied warranty of           ##
'##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            ##
'##  GNU General Public License for more details.                             ##
'##  You should have received a copy of the GNU General Public License        ##
'##  along with this program.  If not, see <http://www.gnu.org/licenses/>.    ##
'##                                                                           ##
'###############################################################################
'***** DS1820 Befehle
Const Read_rom = &H33
Const Skip_rom = &HCC
Const Convertt = &H44
Const Read_ram = &HBE
Const Write_ram = &H4E
Const Copy_ram = &H48
Const Recall_ee = &HB8
Const Read_power = &HB4
Const Match_rom = &H55


Dim Temperatur(4) As Integer
Dim Old_temp(4) As Integer
Declare Sub Temp_messen(kanal As Byte)
Declare Function Convert_temp(kanal As Byte) As String

Goto Ds1820_jumpover


'###############################################################################
'##      S U B R O U T I N E S                                                ##
'###############################################################################

Sub Temp_messen(kanal As Byte)
'Temperatur mit Sensor DS18S20
  Dim Temp As Integer
  Dim 1wpin As Byte
  Dim Bd(9) As Byte
  Local I1 As Integer

  Waitms 120

  'Kanal einem 1wire Bus zuordnen
  If Kanal = 1 Then
   1wpin = 0

  Elseif Kanal = 2 Then
   1wpin = 1

  Elseif Kanal = 3 Then
   1wpin = 2

  Else
   1wpin = 3

  End If

  1wwrite Skip_rom , 1 , Pinc , 1wpin
  1wwrite Convertt , 1 , Pinc , 1wpin                       ' Messung starten

   '**** warten bis abgeschlossen
   I1 = 0
   Do
      Temp = 1wread(1 , Pinc , 1wpin)
      Incr I1
   Loop Until Temp.7 = 1

  'Temperatur auslesen
  If I1 > 5 Then
  1wreset Pinc , 1wpin                                      ' Reset
  1wwrite Skip_rom , 1 , Pinc , 1wpin                       ' Chip ansprechen
  1wwrite Read_ram , 1 , Pinc , 1wpin                       ' Befehl zum Auslesen des Rams
  Bd(1) = 1wread(9 , Pinc , 1wpin)                          ' 9 Bytes lesen
  End If
  1wreset Pinc , 1wpin                                      'Reset

 If Err = 0 Then

  'Wert umrechnen
  Temp = Bd(1)

  'Negative Gradzahl??
  If Bd(2) = &HFF Then
   Temp = Temp - 256
  End If

  'Genauigkeit auf ganze Grad reduzieren
  Temp = Temp / 2

  Temperatur(kanal) = Temp
 Else
  Temperatur(kanal) = 200                                   'Kein gltiger Wert

 End If
End Sub


Function Convert_temp(kanal As Byte) As String
'Temperatur in String konvertieren
 Dim S1 As String * 8
 If Temperatur(kanal) <> 200 Then
 'gltiger Wert
  S1 = "   " + Str(temperatur(kanal))
  S1 = Right(s1 , 3):

  S1 = S1 + "C"

 Else
 'kein Sensor
  S1 = "====="

 End If
 Convert_temp = S1
End Function



Ds1820_jumpover: