$nocompile
'###############################################################################
'##                                                                           ##
'##                              D O G M 1 6 2                                ##
'##                       ===========================                         ##
'##                                                                           ##
'##  Description: DOGM162 serial control driver for BASCOM                    ##
'##                                                                           ##
'##                                                                           ##
'##  Version:     1.0                                       Date: March 2013  ##
'##                                                                           ##
'##  Author:      Hartmut Wendt                                               ##
'##  URL:         www.hwhardsoft.de                                           ##
'##                                                                           ##
'##  Copyright:   GNU Public License V3                                       ##
'##                                                                           ##
'##  note:                                                                    ##
'##  This program is free software: you can redistribute it and/or modify     ##
'##  it under the terms of the GNU General Public License as published by     ##
'##  the Free Software Foundation, either version 3 of the License, or        ##
'##  (at your option) any later version.                                      ##
'##  This program is distributed in the hope that it will be useful,          ##
'##  but WITHOUT ANY WARRANTY; without even the implied warranty of           ##
'##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            ##
'##  GNU General Public License for more details.                             ##
'##  You should have received a copy of the GNU General Public License        ##
'##  along with this program.  If not, see <http://www.gnu.org/licenses/>.    ##
'##                                                                           ##
'###############################################################################

'###############################################################################
'##      S U B R O U T I N E S                                                ##
'###############################################################################

Declare Sub Dogm_lowerline
Declare Sub Dogm_init
Declare Sub Dogm_pushbyte(byval Pushbyte As Byte)
Declare Sub Dogm_clear
Declare Sub Dogm_locate(byval Line As Byte , Byval Pos As Byte)
Declare Sub Dogm_lcd(byval Lcd_ausgabe_text1 As String * 16)
Declare Sub Dogm_cur_off

Goto Dogm_jumpover

'- Subs -------------------------------------------------------------------
Sub Dogm_clear
  Reset Rs                                                  'Command wird gesendet
  Dogm_pushbyte &H01                                        'Clear senden
  Waitms 2                                                  'Timeout abwarten
End Sub

Sub Dogm_lowerline
   Reset Rs                                                 'Command wird gesendet
   Dogm_pushbyte &HC0                                       ' Cursorposition setzen
End Sub

Sub Dogm_locate(byval Line As Byte , Byval Pos As Byte)
   Decr Pos
   Reset Rs                                                 'Command wird gesendet
   If Line = 1 Then
      Dogm_pushbyte &H80 + Pos                              ' Cursorposition setzen
   Else
      Dogm_pushbyte &HC0 + Pos
   End If
End Sub


Sub Dogm_pushbyte(byval Pushbyte As Byte)
   Reset Csb
   Shiftout Si , Clk , Pushbyte , 1 , 8 , 10
   Set Csb
End Sub


Sub Dogm_lcd(byval Lcd_ausgabe_text1 As String * 16)
   Local Dogm_zaehler As Byte
   Local Dogm_byte As Byte
   Local Dogm_char As String * 16
   Set Rs                                                   'Text wird gesendet
   For Dogm_zaehler = 1 To Len(lcd_ausgabe_text1)
      Dogm_char = Mid(lcd_ausgabe_text1 , Dogm_zaehler , 1)
      Dogm_byte = Asc(dogm_char)
      Dogm_pushbyte Dogm_byte
   Next Dogm_zaehler
End Sub


Sub Dogm_cur_off
    Reset Rs
    Dogm_pushbyte &H0C
End Sub


Sub Dogm_init
   Set Clk
   Set Csb
   Reset Rs
   Waitms 40
   Reset Csb
   Dogm_pushbyte &H38 : Waitus 30                           'function set
   Dogm_pushbyte &H39 : Waitus 30                           'function set
   Dogm_pushbyte &H14 : Waitus 30                           'BIAS
   Dogm_pushbyte &H55 : Waitus 30                           '3V-Booster ein, power control
   Dogm_pushbyte &H6D : Waitms 200                          'Follover-Control
   Dogm_pushbyte &H7F : Waitus 30                           'Contrast Set
   Dogm_pushbyte &H38 : Waitus 30                           'function set
   'Dogm_pushbyte &H0C : Waitus 30                           'Display on,Cursor off
   Dogm_pushbyte &H0F : Waitus 30                           'Display ein, Cursor ein, Cursor blinken
   Dogm_pushbyte &H01 : Waitms 2                            'Clear Display
   Dogm_pushbyte &H06 : Waitus 30                           'entry mode auto increment
   Set Csb
End Sub

Dogm_jumpover: